<html>
<head>
<title>OGRE: Ogre::FocusedShadowCameraSetup Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html">FocusedShadowCameraSetup</a></div>
<h1>Ogre::FocusedShadowCameraSetup Class Reference</h1><!-- doxytag: class="Ogre::FocusedShadowCameraSetup" --><!-- doxytag: inherits="Ogre::ShadowCameraSetup" -->Implements the uniform shadow mapping algorithm in focused mode.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::FocusedShadowCameraSetup:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1FocusedShadowCameraSetup-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#f4fec2364b3404a7738e9b5ede0710e7">FocusedShadowCameraSetup</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default constructor.  <a href="#f4fec2364b3404a7738e9b5ede0710e7"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#a37dc46bc1cc5a65359c66fdb539b74c">~FocusedShadowCameraSetup</a> (void)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default destructor.  <a href="#a37dc46bc1cc5a65359c66fdb539b74c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#4859f949e592b63e5f211f85f510cb37">getShadowCamera</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam, const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *vp, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *texCam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a uniform shadow camera with a focused view.  <a href="#4859f949e592b63e5f211f85f510cb37"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#f57854c45cd48033da1cb28e316901dc">setUseAggressiveFocusRegion</a> (bool aggressive)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to use the more agressive approach to deciding on the focus region or not.  <a href="#f57854c45cd48033da1cb28e316901dc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#89fc1444a88d8c20c35ee50a8c518564">getUseAggressiveFocusRegion</a> () const </td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#7236f92a6006f84b7441adce882713df">calculateShadowMappingMatrix</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_view, <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *out_proj, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *out_cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the standard shadow mapping matrix.  <a href="#7236f92a6006f84b7441adce882713df"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#561c5825cdc94896a738e4eb3a0b8852">calculateB</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *out_bodyB) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the intersection bodyB.  <a href="#561c5825cdc94896a738e4eb3a0b8852"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0706a0e7b7ec6aecf9639dbe5b9cc7a2">calculateLVS</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;light, const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;sceneBB, <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *out_LVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Calculates the bodyLVS.  <a href="#0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#5a463b751319df295758fa832e9f8e2d">getLSProjViewDir</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;lightSpace, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;cam, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;bodyLVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the projection view direction.  <a href="#5a463b751319df295758fa832e9f8e2d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#023ab991324e937410c0b8bc654085e5">getNearCameraPoint_ws</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;viewMatrix, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;bodyLVS) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a valid near-point seen by the camera.  <a href="#023ab991324e937410c0b8bc654085e5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1438dc104a74c79bbe98df922e31651b">transformToUnitCube</a> (const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;m, const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;body) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled.  <a href="#1438dc104a74c79bbe98df922e31651b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2717983dfbfaff59191bb51fae350ece">buildViewMatrix</a> (const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;pos, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;dir, const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;up) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Builds a view matrix.  <a href="#2717983dfbfaff59191bb51fae350ece"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0ebae20e4252d229af9524a8690ecc11">mTempFrustum</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Temporary preallocated frustum to set up a projection matrix in calculateShadowMappingMatrix().  <a href="#0ebae20e4252d229af9524a8690ecc11"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1cdb9e5c72f7bbb936b2ba84cf605787">mLightFrustumCamera</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Temporary preallocated camera to set up a light frustum for clipping in calculateB.  <a href="#1cdb9e5c72f7bbb936b2ba84cf605787"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#113a55085b7c23a1004a4be9f3155c1c">mLightFrustumCameraCalculated</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#c22ea363ab7fc61d60f0c1518015cb6b">mUseAggressiveRegion</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Use tighter focus region?  <a href="#c22ea363ab7fc61d60f0c1518015cb6b"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#e784e0376eb99fa60f2c4a995ccd162e">mBodyB</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#84c5bc98d3d36f4e3f858d726d1cb19e">mPointListBodyB</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#69328121d415c6e9033ff0e3d7d21cd2">mPointListBodyLVS</a></td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2022a48e9e37aa409682d320233cfa09">msNormalToLightSpace</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Transform to or from light space as defined by Wimmer et al.  <a href="#2022a48e9e37aa409682d320233cfa09"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#3c6218ad4ccccd28374444f1ecd2b3d5">msLightSpaceToNormal</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal class holding a point list representation of a convex body.  <a href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html#_details">More...</a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Implements the uniform shadow mapping algorithm in focused mode. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Differs from the default shadow mapping projection in that it focuses the shadow map on the visible areas of the scene. This results in better shadow map texel usage, at the expense of some 'swimming' of the shadow texture on receivers as the basis is constantly being reevaluated. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Original implementation by Matthias Fink &lt;<a href="mailto:matthias.fink@web.de">matthias.fink@web.de</a>&gt;, 2006. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00052">52</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="f4fec2364b3404a7738e9b5ede0710e7"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::FocusedShadowCameraSetup" ref="f4fec2364b3404a7738e9b5ede0710e7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::FocusedShadowCameraSetup::FocusedShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default constructor. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Temporary frustum and camera set up here. </dd></dl>

</div>
</div><p>
<a class="anchor" name="a37dc46bc1cc5a65359c66fdb539b74c"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::~FocusedShadowCameraSetup" ref="a37dc46bc1cc5a65359c66fdb539b74c" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::FocusedShadowCameraSetup::~FocusedShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Default destructor. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Temporary frustum and camera destroyed here. </dd></dl>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="7236f92a6006f84b7441adce882713df"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateShadowMappingMatrix" ref="7236f92a6006f84b7441adce882713df" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, Matrix4 *out_view, Matrix4 *out_proj, Camera *out_cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateShadowMappingMatrix           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>out_view</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>out_proj</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>out_cam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the standard shadow mapping matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Provides the view and projection matrix for standard shadow mapping. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>You can choose which things you want to have: view matrix and/or projection matrix and/or shadow camera. Passing a NULL value as parameter ignores the generation of this specific value. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sm,:</em>&nbsp;</td><td>scene manager </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>currently active light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_view,:</em>&nbsp;</td><td>calculated uniform view shadow mapping matrix (may be NULL) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_proj,:</em>&nbsp;</td><td>calculated uniform projection shadow mapping matrix (may be NULL) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_cam,:</em>&nbsp;</td><td>calculated uniform shadow camera (may be NULL) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="561c5825cdc94896a738e4eb3a0b8852"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateB" ref="561c5825cdc94896a738e4eb3a0b8852" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, PointListBody *out_bodyB) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateB           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&nbsp;</td>
          <td class="paramname"> <em>out_bodyB</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the intersection bodyB. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The intersection bodyB consists of the concatenation the cam frustum clipped by the scene bounding box followed by a convex hullification with the light's position and the clipping with the scene bounding box and the light frustum: ((V  S) + l)  S  L (: convex intersection, +: convex hull operation). For directional lights the bodyB is assembled out of the camera frustum clipped by the scene bounding box followed by the extrusion of all available bodyB points towards the negative light direction. The rays are intersected by a maximum bounding box and added to the bodyB points to form the final intersection bodyB point list. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>sm,:</em>&nbsp;</td><td>scene manager </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>currently active camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>currently active light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>sceneBB,:</em>&nbsp;</td><td>scene bounding box for clipping operations </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_bodyB,:</em>&nbsp;</td><td>final intersection bodyB point list </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="0706a0e7b7ec6aecf9639dbe5b9cc7a2"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::calculateLVS" ref="0706a0e7b7ec6aecf9639dbe5b9cc7a2" args="(const SceneManager &amp;sm, const Camera &amp;cam, const Light &amp;light, const AxisAlignedBox &amp;sceneBB, PointListBody *out_LVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::calculateLVS           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AxisAlignedBox.html">AxisAlignedBox</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>sceneBB</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> *&nbsp;</td>
          <td class="paramname"> <em>out_LVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Calculates the bodyLVS. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Calculates the bodyLVS which consists of the convex intersection operation affecting the light frustum, the view frustum, and the current scene bounding box is used to find suitable positions in the viewer's frustum to build the rotation matrix L_r. This matrix is applied after the projection matrix L_p to avoid an accidental flip of the frustum orientation for views tilted with respect to the shadow map. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>scene,:</em>&nbsp;</td><td>holds all potential occluders / receivers as one single bounding box of the currently active scene node </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>current viewer camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>light,:</em>&nbsp;</td><td>current light </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>out_LVS,:</em>&nbsp;</td><td>intersection body LVS (world coordinates) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="5a463b751319df295758fa832e9f8e2d"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getLSProjViewDir" ref="5a463b751319df295758fa832e9f8e2d" args="(const Matrix4 &amp;lightSpace, const Camera &amp;cam, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::FocusedShadowCameraSetup::getLSProjViewDir           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>lightSpace</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the projection view direction. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>After the matrix L_p is applied the orientation of the light space may tilt for non-identity projections. To prevent a false shadow cast the real view direction is evaluated and applied to the light matrix L. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>lightSpace,:</em>&nbsp;</td><td>matrix of the light space transformation </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>cam,:</em>&nbsp;</td><td>current viewer camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="023ab991324e937410c0b8bc654085e5"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getNearCameraPoint_ws" ref="023ab991324e937410c0b8bc654085e5" args="(const Matrix4 &amp;viewMatrix, const PointListBody &amp;bodyLVS) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Vector3.html">Vector3</a> Ogre::FocusedShadowCameraSetup::getNearCameraPoint_ws           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>viewMatrix</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>bodyLVS</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a valid near-point seen by the camera. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Returns a point that is situated near the camera by analyzing the bodyLVS that contains all the relevant scene space in front of the light and the camera in a point list array. The view matrix is relevant because the nearest point in front of the camera should be determined. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>viewMatrix,:</em>&nbsp;</td><td>view matrix of the current camera </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bodyLVS,:</em>&nbsp;</td><td>intersection body LVS (relevant space in front of the camera) </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="1438dc104a74c79bbe98df922e31651b"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::transformToUnitCube" ref="1438dc104a74c79bbe98df922e31651b" args="(const Matrix4 &amp;m, const PointListBody &amp;body) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::FocusedShadowCameraSetup::transformToUnitCube           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>body</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Transforms a given body to the unit cube (-1,-1,-1) / (+1,+1,+1) with a specific shadow matrix enabled. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Transforms a given point list body object with the matrix m and then maps its extends to a (-1,-1,-1) / (+1,+1,+1) unit cube </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>m,:</em>&nbsp;</td><td>transformation matrix applied on the point list body </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>body,:</em>&nbsp;</td><td>contains the points of the extends of all valid scene elements which are mapped to the unit cube </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="2717983dfbfaff59191bb51fae350ece"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::buildViewMatrix" ref="2717983dfbfaff59191bb51fae350ece" args="(const Vector3 &amp;pos, const Vector3 &amp;dir, const Vector3 &amp;up) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> Ogre::FocusedShadowCameraSetup::buildViewMatrix           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>dir</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>up</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Builds a view matrix. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Builds a standard view matrix out of a given position, direction and up vector. </dd></dl>

</div>
</div><p>
<a class="anchor" name="4859f949e592b63e5f211f85f510cb37"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getShadowCamera" ref="4859f949e592b63e5f211f85f510cb37" args="(const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::FocusedShadowCameraSetup::getShadowCamera           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&nbsp;</td>
          <td class="paramname"> <em>vp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>texCam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns a uniform shadow camera with a focused view. 
<p>

<p>Implements <a class="el" href="classOgre_1_1ShadowCameraSetup.html#672a8fa796007d122d3555b09c611d2e">Ogre::ShadowCameraSetup</a>.</p>

<p>Reimplemented in <a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#d8969d629ddf8c9e01f22c5342888b99">Ogre::LiSPSMShadowCameraSetup</a>.</p>

</div>
</div><p>
<a class="anchor" name="f57854c45cd48033da1cb28e316901dc"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::setUseAggressiveFocusRegion" ref="f57854c45cd48033da1cb28e316901dc" args="(bool aggressive)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::FocusedShadowCameraSetup::setUseAggressiveFocusRegion           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>aggressive</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to use the more agressive approach to deciding on the focus region or not. 
<p>
<dl class="note" compact><dt><b>Note:</b></dt><dd>There are 2 approaches that can be used to define the focus region, the more aggressive way introduced by Wimmer et al, or the original way as described in Stamminger et al. Wimmer et al's way tends to come up with a tighter focus region but in rare cases (mostly highly glancing angles) can cause some shadow casters to be clipped incorrectly. By default the more aggressive approach is used since it leads to significantly better results in most cases, but if you experience clipping issues, you can use the less agressive version. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>aggressive</em>&nbsp;</td><td>True to use the more agressive approach, false otherwise. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00272">272</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="89fc1444a88d8c20c35ee50a8c518564"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::getUseAggressiveFocusRegion" ref="89fc1444a88d8c20c35ee50a8c518564" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::FocusedShadowCameraSetup::getUseAggressiveFocusRegion           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00274">274</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="2022a48e9e37aa409682d320233cfa09"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::msNormalToLightSpace" ref="2022a48e9e37aa409682d320233cfa09" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#2022a48e9e37aa409682d320233cfa09">Ogre::FocusedShadowCameraSetup::msNormalToLightSpace</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Transform to or from light space as defined by Wimmer et al. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Point and spot lights need to be converted to directional lights to enable a 1:1 light mapping. Otherwise a directional light may become a point light or a point sink (opposite of a light source) or point/spot lights may become directional lights or light sinks. The light direction is always -y. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00062">62</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="3c6218ad4ccccd28374444f1ecd2b3d5"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::msLightSpaceToNormal" ref="3c6218ad4ccccd28374444f1ecd2b3d5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#3c6218ad4ccccd28374444f1ecd2b3d5">Ogre::FocusedShadowCameraSetup::msLightSpaceToNormal</a><code> [static, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00063">63</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0ebae20e4252d229af9524a8690ecc11"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mTempFrustum" ref="0ebae20e4252d229af9524a8690ecc11" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#0ebae20e4252d229af9524a8690ecc11">Ogre::FocusedShadowCameraSetup::mTempFrustum</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Temporary preallocated frustum to set up a projection matrix in calculateShadowMappingMatrix(). 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00068">68</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1cdb9e5c72f7bbb936b2ba84cf605787"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mLightFrustumCamera" ref="1cdb9e5c72f7bbb936b2ba84cf605787" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Camera.html">Camera</a>* <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#1cdb9e5c72f7bbb936b2ba84cf605787">Ogre::FocusedShadowCameraSetup::mLightFrustumCamera</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Temporary preallocated camera to set up a light frustum for clipping in calculateB. 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00072">72</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="113a55085b7c23a1004a4be9f3155c1c"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mLightFrustumCameraCalculated" ref="113a55085b7c23a1004a4be9f3155c1c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#113a55085b7c23a1004a4be9f3155c1c">Ogre::FocusedShadowCameraSetup::mLightFrustumCameraCalculated</a><code> [mutable, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00073">73</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c22ea363ab7fc61d60f0c1518015cb6b"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mUseAggressiveRegion" ref="c22ea363ab7fc61d60f0c1518015cb6b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#c22ea363ab7fc61d60f0c1518015cb6b">Ogre::FocusedShadowCameraSetup::mUseAggressiveRegion</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Use tighter focus region? 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00076">76</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e784e0376eb99fa60f2c4a995ccd162e"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mBodyB" ref="e784e0376eb99fa60f2c4a995ccd162e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ConvexBody.html">ConvexBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#e784e0376eb99fa60f2c4a995ccd162e">Ogre::FocusedShadowCameraSetup::mBodyB</a><code> [mutable, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00139">139</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="84c5bc98d3d36f4e3f858d726d1cb19e"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mPointListBodyB" ref="84c5bc98d3d36f4e3f858d726d1cb19e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#84c5bc98d3d36f4e3f858d726d1cb19e">Ogre::FocusedShadowCameraSetup::mPointListBodyB</a><code> [mutable, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00140">140</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="69328121d415c6e9033ff0e3d7d21cd2"></a><!-- doxytag: member="Ogre::FocusedShadowCameraSetup::mPointListBodyLVS" ref="69328121d415c6e9033ff0e3d7d21cd2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1FocusedShadowCameraSetup_1_1PointListBody.html">PointListBody</a> <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#69328121d415c6e9033ff0e3d7d21cd2">Ogre::FocusedShadowCameraSetup::mPointListBodyLVS</a><code> [mutable, protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html#l00141">141</a> of file <a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCameraSetupFocused_8h-source.html">OgreShadowCameraSetupFocused.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:34 2008
</p>
</body>
</html>
